Index: trunk/gui/scripts/deviceViewer1D.tcl
===================================================================
--- trunk/gui/scripts/deviceViewer1D.tcl	(revision 6716)
+++ trunk/gui/scripts/deviceViewer1D.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: deviceViewer1D - visualizer for 1D device geometries
@@ -11,18 +10,14 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
-package require Img
 package require BLT
 
+option add *DeviceViewer1D.width 4i widgetDefault
+option add *DeviceViewer1D.height 4i widgetDefault
 option add *DeviceViewer1D.padding 4 widgetDefault
 option add *DeviceViewer1D.deviceSize 0.25i widgetDefault
 option add *DeviceViewer1D.deviceOutline black widgetDefault
-option add *DeviceViewer1D*graph.width 3i widgetDefault
-option add *DeviceViewer1D*graph.height 2i widgetDefault
 
 itcl::class Rappture::DeviceViewer1D {
@@ -30,20 +25,13 @@
 
     itk_option define -device device Device ""
-
-    constructor {owner args} { # defined below }
+    itk_option define -tool tool Tool ""
+
+    constructor {args} { # defined below }
     destructor { # defined below }
 
-    public method add {dataobj {settings ""}}
-    public method get {}
-    public method delete {args}
-    public method parameters {title args} { # do nothing }
-
     public method controls {option args}
-    public method download {option args}
-
-    protected method _loadDevice {}
-    protected method _loadParameters {frame path}
-    protected method _changeTabs {{why -program}}
-    protected method _fixSize {}
+                                                                                
+    protected method _fixTabs {}
+    protected method _changeTabs {}
     protected method _fixAxes {}
     protected method _align {}
@@ -54,14 +42,12 @@
     protected method _controlSet {widget libObj path}
 
-    private variable _owner ""      ;# thing managing this control
-    private variable _dlist ""      ;# list of dataobj objects
-    private variable _dobj2raise    ;# maps dataobj => raise flag
-    private variable _device ""     ;# XML library with <structure>
+    private variable _device ""     ;# LibraryObj for device rep
+    private variable _tool ""       ;# LibraryObj for tool parameters
     private variable _tab2fields    ;# maps tab name => list of fields
-    private variable _field2parm    ;# maps field path => parameter name
     private variable _units ""      ;# units for field being edited
+    private variable _restrict ""   ;# restriction expr for field being edited
     private variable _marker        ;# marker currently being edited
 }
-
+                                                                                
 itk::usual DeviceViewer1D {
 }
@@ -70,7 +56,6 @@
 # CONSTRUCTOR
 # ----------------------------------------------------------------------
-itcl::body Rappture::DeviceViewer1D::constructor {owner args} {
-    set _owner $owner
-
+itcl::body Rappture::DeviceViewer1D::constructor {args} {
+    itk_option add hull.width hull.height
     pack propagate $itk_component(hull) no
 
@@ -78,5 +63,5 @@
         blt::tabset $itk_interior.tabs -borderwidth 0 -relief flat \
             -side bottom -tearoff 0 \
-            -selectcommand [itcl::code $this _changeTabs -user]
+            -selectcommand [itcl::code $this _changeTabs]
     } {
         keep -activebackground -activeforeground
@@ -84,7 +69,6 @@
         rename -highlightbackground -background background Background
         keep -highlightcolor -highlightthickness
+        keep -selectbackground -selectforeground
         keep -tabbackground -tabforeground
-        rename -selectbackground -background background Background
-        rename -selectforeground -foreground foreground Foreground
     }
     pack $itk_component(tabs) -expand yes -fill both
@@ -94,8 +78,8 @@
     }
 
-    itk_component add top {
-        frame $itk_component(inner).top
-    }
-    pack $itk_component(top) -fill x
+    itk_component add ambient {
+        frame $itk_component(inner).ambient
+    }
+    pack $itk_component(ambient) -side top -fill x
 
     itk_component add layout {
@@ -106,5 +90,6 @@
     itk_component add graph {
         blt::graph $itk_component(inner).graph \
-            -highlightthickness 0 -plotpadx 0 -plotpady 0
+            -highlightthickness 0 -plotpadx 0 -plotpady 0 \
+            -width 3i -height 3i
     } {
         keep -background -foreground -cursor -font
@@ -114,6 +99,6 @@
 
     bind $itk_component(graph) <Configure> "
-        [list after cancel [list catch [itcl::code $this _align]]]
-        [list after 100 [list catch [itcl::code $this _align]]]
+        after cancel [itcl::code $this _fixAxes]
+        after idle [itcl::code $this _fixAxes]
     "
 
@@ -131,7 +116,4 @@
 
     eval itk_initialize $args
-
-    after cancel [list catch [itcl::code $this _fixSize]]
-    after idle [list catch [itcl::code $this _fixSize]]
 }
 
@@ -146,158 +128,49 @@
     after cancel [list catch [itcl::code $this _fixAxes]]
     after cancel [list catch [itcl::code $this _align]]
-    after cancel [list catch [itcl::code $this _loadDevice]]
-}
-
-# ----------------------------------------------------------------------
-# USAGE: add <dataobj> ?<settings>?
-#
-# Clients use this to add a data object to the plot.  The optional
-# <settings> are used to configure the plot.  Allowed settings are
-# -color, -brightness, -width, -linestyle, and -raise. Only
-# -brightness and -raise do anything.
-# ----------------------------------------------------------------------
-itcl::body Rappture::DeviceViewer1D::add {dataobj {settings ""}} {
-    array set params {
-        -color auto
-        -brightness 0
-        -width 1
-        -raise 0
-        -linestyle solid
-        -description ""
-        -param ""
-    }
-    array set params $settings
-
-    set pos [lsearch -exact $_dlist $dataobj]
-
-    if {$pos < 0} {
-        if {![Rappture::library isvalid $dataobj]} {
-            error "bad value \"$dataobj\": should be Rappture::library object"
-        }
-
-        lappend _dlist $dataobj
-        set _dobj2raise($dataobj) $params(-raise)
-
-        after cancel [list catch [itcl::code $this _loadDevice]]
-        after idle [list catch [itcl::code $this _loadDevice]]
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: get
-#
-# Clients use this to query the list of objects being plotted, in
-# order from bottom to top of this result.
-# ----------------------------------------------------------------------
-itcl::body Rappture::DeviceViewer1D::get {} {
-    # put the dataobj list in order according to -raise options
-    set dlist $_dlist
-    foreach obj $dlist {
-        if {[info exists _dobj2raise($obj)] && $_dobj2raise($obj)} {
-            set i [lsearch -exact $dlist $obj]
-            if {$i >= 0} {
-                set dlist [lreplace $dlist $i $i]
-                lappend dlist $obj
-            }
-        }
-    }
-    return $dlist
-}
-
-# ----------------------------------------------------------------------
-# USAGE: delete ?<dataobj> <dataobj> ...?
-#
-# Clients use this to delete a dataobj from the plot. If no dataobjs
-# are specified, then all dataobjs are deleted.
-# ----------------------------------------------------------------------
-itcl::body Rappture::DeviceViewer1D::delete {args} {
-    if {[llength $args] == 0} {
-        set args $_dlist
-    }
-
-    # delete all specified dataobjs
-    set changed 0
-    foreach dataobj $args {
-        set pos [lsearch -exact $_dlist $dataobj]
-        if {$pos >= 0} {
-            set _dlist [lreplace $_dlist $pos $pos]
-            catch {unset _dobj2raise($dataobj)}
-            set changed 1
-        }
-    }
-
-    # if anything changed, then rebuild the plot
-    if {$changed} {
-        after cancel [list catch [itcl::code $this _loadDevice]]
-        after idle [list catch [itcl::code $this _loadDevice]]
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: controls insert <pos> <xmlobj> <path>
+}
+
+# ----------------------------------------------------------------------
+# USAGE: controls add <parameter>
+# USAGE: controls remove <parameter>|all
 #
 # Clients use this to add a control to the internal panels of this
-# widget.  Such controls are usually placed at the top of the widget,
-# but if possible, they are integrated directly onto the device
-# layout or the field area.
+# widget.  If the <parameter> is ambient*, then the control is added
+# to the top, so it goes along with the layout of the device.  If
+# it is device.field*, then it goes in one of the field panels.
 # ----------------------------------------------------------------------
 itcl::body Rappture::DeviceViewer1D::controls {option args} {
     switch -- $option {
-        insert {
-            if {[llength $args] != 3} {
-                error "wrong # args: should be \"controls insert pos xmlobj path\""
+        add {
+            if {[llength $args] != 1} {
+                error "wrong # args: should be \"controls add parameter\""
             }
-            set pos [lindex $args 0]
-            set xmlobj [lindex $args 1]
-            set path [lindex $args 2]
-            if {[string match *structure.parameters* $path]} {
-            } elseif {[string match structure.components* $path]} {
-                $itk_component(layout) controls insert $pos $xmlobj $path
+            set path [lindex $args 0]
+            if {[string match device.field* $path]} {
+            } elseif {[string match device.recipe* $path]} {
+                $itk_component(layout) controls add $path
+            } else {
+                _controlCreate $itk_component(ambient) $_tool $path
             }
         }
+        remove {
+            error "not yet implemented"
+        }
         default {
-            error "bad option \"$option\": should be insert"
-        }
-    }
-}
-
-
-# ----------------------------------------------------------------------
-# USAGE: download coming
-# USAGE: download controls <downloadCommand>
-# USAGE: download now
-#
-# Clients use this method to create a downloadable representation
-# of the plot.  Returns a list of the form {ext string}, where
-# "ext" is the file extension (indicating the type of data) and
-# "string" is the data itself.
-# ----------------------------------------------------------------------
-itcl::body Rappture::DeviceViewer1D::download {option args} {
-    switch $option {
-        coming {
-            # nothing to do
-        }
-        controls {
-            # no controls for this download yet
-            return ""
-        }
-        now {
-            return ""  ;# not implemented yet!
-        }
-        default {
-            error "bad option \"$option\": should be coming, controls, now"
-        }
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _loadDevice
+            error "bad option \"$option\": should be add or remove"
+        }
+    }
+}
+
+# ----------------------------------------------------------------------
+# USAGE: _fixTabs
 #
 # Used internally to search for fields and create corresponding
 # tabs whenever a device is installed into this viewer.
-# ----------------------------------------------------------------------
-itcl::body Rappture::DeviceViewer1D::_loadDevice {} {
-    set _device [lindex [get] end]
-
+#
+# If there are no tabs, then the widget is packed so that it appears
+# directly.  Otherwise, the interior reconfigured and assigned to
+# the current tab.
+# ----------------------------------------------------------------------
+itcl::body Rappture::DeviceViewer1D::_fixTabs {} {
     #
     # Release any info left over from the last device.
@@ -307,9 +180,4 @@
     }
     catch {unset _tab2fields}
-    catch {unset _field2parm}
-
-    if {[winfo exists $itk_component(top).cntls]} {
-        $itk_component(top).cntls delete 0 end
-    }
 
     #
@@ -318,12 +186,14 @@
     #
     if {$_device != ""} {
-        foreach nn [$_device children fields] {
-            set name [$_device get fields.$nn.about.label]
-            if {$name == ""} {
-                set name $nn
+        foreach nn [$_device get -children] {
+            if {[string match field* $nn]} {
+                set name [$_device get $nn.label]
+                if {$name == ""} {
+                    set name $nn
+                }
+
+                set fobj [Rappture::Field ::#auto $_device $_device $nn]
+                lappend _tab2fields($name) $fobj
             }
-
-            set fobj [Rappture::Field ::#auto $_device fields.$nn]
-            lappend _tab2fields($name) $fobj
         }
     }
@@ -336,7 +206,7 @@
     if {[llength $tabs] <= 0} {
         #
-        # No fields?  Then we don't need to bother with tabs.
-        # Just pack the inner frame directly.  If there are no
-        # fields, get rid of the graph.
+        # No fields or one field?  Then we don't need to bother
+        # with tabs.  Just pack the inner frame directly.  If
+        # there are no fields, get rid of the graph.
         #
         pack $itk_component(inner) -expand yes -fill both
@@ -357,24 +227,8 @@
 
         foreach name $tabs {
-            $itk_component(tabs) insert end $name \
-                -activebackground $itk_option(-background)
+            $itk_component(tabs) insert end $name
         }
         $itk_component(tabs) select 0
     }
-
-    #
-    # Scan through and look for any parameters in the <structure>.
-    # Register any parameters associated with fields, so we can
-    # add them as active controls whenever we install new fields.
-    # Create controls for any remaining parameters, so the user
-    # can see that there's something to adjust.
-    #
-    if {$_device != ""} {
-        _loadParameters $itk_component(top) parameters
-    }
-
-    #
-    # Install the first tab
-    #
     _changeTabs
 
@@ -385,77 +239,13 @@
     $itk_component(graph) configure \
         -rightmargin [$itk_component(layout) extents bar3D]
-
-    after cancel [list catch [itcl::code $this _fixSize]]
-    after idle [list catch [itcl::code $this _fixSize]]
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _loadParameters <frame> <path>
-#
-# Used internally in _loadDevice to load child parameters at the
-# specified <path> into the <frame>.  If any of the children are
-# groups, then this is called recursively to fill in the group
-# children.
-# ----------------------------------------------------------------------
-itcl::body Rappture::DeviceViewer1D::_loadParameters {frame path} {
-    foreach cname [$_device children $path] {
-        set handled 0
-        set type [$_device element -as type $path.$cname]
-        if {$type == "about"} {
-            continue
-        }
-        if {$type == "number"} {
-            set name [$_device element -as id $path.$cname]
-
-            # look for a field that uses this parameter
-            set found ""
-            foreach fname [$_device children fields] {
-                foreach comp [$_device children fields.$fname] {
-                    set v [$_device get fields.$fname.$comp.constant]
-                    if {[string equal $v $name]} {
-                        set found "fields.$fname.$comp"
-                        break
-                    }
-                }
-                if {"" != $found} break
-            }
-
-            if {"" != $found} {
-                set _field2parm($found) $name
-                set handled 1
-            }
-        }
-
-        #
-        # Any parameter that was not handled above should be handled
-        # here, by adding it to a control panel above the device
-        # layout area.
-        #
-        if {!$handled} {
-            if {![winfo exists $frame.cntls]} {
-                Rappture::Controls $frame.cntls $_owner
-                pack $frame.cntls -expand yes -fill both
-            }
-            $frame.cntls insert end $path.$cname
-
-            #
-            # If this is a group, then we must add its children
-            # recursively.
-            #
-            if {$type == "group"} {
-                set gr [$frame.cntls control -value end]
-                _loadParameters [$gr component inner] $path.$cname
-            }
-        }
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _changeTabs ?-user|-program?
+}
+
+# ----------------------------------------------------------------------
+# USAGE: _changeTabs
 #
 # Used internally to change the field being displayed whenever a new
 # tab is selected.
 # ----------------------------------------------------------------------
-itcl::body Rappture::DeviceViewer1D::_changeTabs {{why -program}} {
+itcl::body Rappture::DeviceViewer1D::_changeTabs {} {
     set graph $itk_component(graph)
 
@@ -473,8 +263,4 @@
     }
 
-    if {$why eq "-user"} {
-        Rappture::Logger::log device1D -field $name
-    }
-
     #
     # Update the graph to show the current field.
@@ -484,22 +270,10 @@
 
     foreach {zmin zmax} [$itk_component(layout) limits] { break }
-    if {$zmin != "" && $zmin < $zmax} {
-        $graph axis configure x -min $zmin -max $zmax
-    }
-
-    if {$_device != ""} {
-        set units [$_device get units]
-        if {$units != "arbitrary"} {
-            $graph axis configure x -hide no -title "Position ($units)"
-        } else {
-            $graph axis configure x -hide yes
-        }
-    } else {
-        $graph axis configure x -hide no -title "Position"
-    }
-    $graph axis configure x -checklimits no
+    if {$zmax > $zmin} {
+        $graph axis configure x -min $zmin -max $zmax -title "Position (um)"
+    }
 
     # turn on auto limits
-    $graph axis configure y -min "" -max "" -checklimits no
+    $graph axis configure y -min "" -max ""
 
     set flist ""
@@ -521,4 +295,10 @@
         }
 
+        if {[info exists hints(restrict)]} {
+            set _restrict $hints(restrict)
+        } else {
+            set _restrict ""
+        }
+
         if {[info exists hints(scale)]
               && [string match log* $hints(scale)]} {
@@ -529,15 +309,7 @@
 
         foreach comp [$fobj components] {
-            # can only handle 1D meshes here
-            if {[$fobj components -dimensions $comp] != "1D"} {
-                continue
-            }
-
             set elem "elem[incr n]"
-            set xv [$fobj mesh $comp]
-            set yv [$fobj values $comp]
-
-            $graph element create $elem -x $xv -y $yv \
-                -color black -symbol "" -linewidth 2
+            foreach {xv yv} [$fobj vectors $comp] { break }
+            $graph element create $elem -x $xv -y $yv -symbol "" -linewidth 2
 
             if {[info exists hints(color)]} {
@@ -546,15 +318,12 @@
 
             foreach {path x y val} [$fobj controls get $comp] {
-                if {$path != ""} {
-                    set id "control[incr n]"
-                    $graph marker create text -coords [list $x $y] \
-                        -text $val -anchor s -name $id -background ""
-                    $graph marker bind $id <Enter> \
-                        [itcl::code $this _marker enter $id]
-                    $graph marker bind $id <Leave> \
-                        [itcl::code $this _marker leave $id]
-                    $graph marker bind $id <ButtonPress> \
-                        [itcl::code $this _marker edit $id $fobj/$path]
-                }
+                $graph marker create text -coords [list $x $y] \
+                    -text $val -anchor s -name $comp.$x
+                $graph marker bind $comp.$x <Enter> \
+                    [itcl::code $this _marker enter $comp.$x]
+                $graph marker bind $comp.$x <Leave> \
+                    [itcl::code $this _marker leave $comp.$x]
+                $graph marker bind $comp.$x <ButtonPress> \
+                    [itcl::code $this _marker edit $comp.$x $fobj/$path]
             }
         }
@@ -562,21 +331,6 @@
 
     # let the widget settle, then fix the axes to "nice" values
-    after cancel [list catch [itcl::code $this _fixAxes]]
-    after 100 [list catch [itcl::code $this _fixAxes]]
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _fixSize
-#
-# Used internally to fix the overall size of this widget based on
-# the various parts inside.  Sets the requested width/height of the
-# widget so that it is big enough to display the device and its
-# fields.
-# ----------------------------------------------------------------------
-itcl::body Rappture::DeviceViewer1D::_fixSize {} {
-    update idletasks
-    set w [winfo reqwidth $itk_component(tabs)]
-    set h [winfo reqheight $itk_component(tabs)]
-    component hull configure -width $w -height $h
+    after cancel [itcl::code $this _fixAxes]
+    after 20 [itcl::code $this _fixAxes]
 }
 
@@ -590,9 +344,4 @@
 itcl::body Rappture::DeviceViewer1D::_fixAxes {} {
     set graph $itk_component(graph)
-    if {![winfo ismapped $graph]} {
-        after cancel [list catch [itcl::code $this _fixAxes]]
-        after 100 [list catch [itcl::code $this _fixAxes]]
-        return
-    }
 
     #
@@ -604,5 +353,4 @@
     #
     set log [$graph axis cget y -logscale]
-    $graph axis configure y -min "" -max ""
     foreach {min max} [$graph axis limits y] { break }
 
@@ -688,21 +436,7 @@
         enter {
             $itk_component(graph) marker configure $name -background #e5e5e5
-            #
-            # BE CAREFUL:  Need an update here to force the graph to
-            #   refresh itself or else a subsequent click on the
-            #   marker will ignore the text that was recently changed,
-            #   and fail to generate a <ButtonPress> event!
-            #
-            update idletasks
         }
         leave {
             $itk_component(graph) marker configure $name -background ""
-            #
-            # BE CAREFUL:  Need an update here to force the graph to
-            #   refresh itself or else a subsequent click on the
-            #   marker will ignore the text that was recently changed,
-            #   and fail to generate a <ButtonPress> event!
-            #
-            update idletasks
         }
         edit {
@@ -740,13 +474,18 @@
                     bell
                     Rappture::Tooltip::cue $itk_component(geditor) $result
-                    Rappture::Logger::log warning $_marker(path) $result
                     return 0
                 }
-            }
-            if {[catch {$_marker(fobj) controls validate $_marker(path) $name} result]} {
-                bell
-                Rappture::Tooltip::cue $itk_component(geditor) $result
-                Rappture::Logger::log warning $_marker(path) $result
-                return 0
+                if {"" != $_restrict
+                      && [catch {Rappture::Units::convert $result \
+                        -context $_units -to $_units -units off} value] == 0} {
+
+                    set rexpr $_restrict
+                    regsub -all value $rexpr {$value} rexpr
+                    if {[catch {expr $rexpr} result] == 0 && !$result} {
+                        bell
+                        Rappture::Tooltip::cue $itk_component(geditor) "Should satisfy the condition: $_restrict"
+                        return 0
+                    }
+                }
             }
             return 1
@@ -761,7 +500,5 @@
 
             $_marker(fobj) controls put $_marker(path) $value
-            $_owner changed $_marker(path)
             event generate $itk_component(hull) <<Edit>>
-            Rappture::Logger::log input $_marker(path) $value
 
             _changeTabs
@@ -779,8 +516,9 @@
 itcl::body Rappture::DeviceViewer1D::_controlCreate {container libObj path} {
     set presets ""
-    foreach pre [$libObj children -type preset $path] {
+    set npre [$libObj get -count $path.preset]
+    for {set i 0} {$i < $npre} {incr i} {
         lappend presets \
-            [$libObj get $path.$pre.value] \
-            [$libObj get $path.$pre.label]
+            [$libObj get $path.preset$i.value] \
+            [$libObj get $path.preset$i.label]
     }
 
@@ -801,5 +539,5 @@
 
     # create the widget
-    $type $w -units $units -presets $presets -log $path
+    $type $w -units $units -presets $presets
     pack $w -side top -anchor w
     bind $w <<Value>> [itcl::code $this _controlSet $w $libObj $path]
@@ -868,13 +606,25 @@
 itcl::configbody Rappture::DeviceViewer1D::device {
     if {$itk_option(-device) != ""} {
-        if {![Rappture::library isvalid $itk_option(-device)]} {
+        if {![Rappture::Library::valid $itk_option(-device)]} {
             error "bad value \"$itk_option(-device)\": should be Rappture::Library"
         }
     }
-
-    delete
-    if {"" != $itk_option(-device)} {
-        add $itk_option(-device)
-    }
-    _loadDevice
-}
+    set _device $itk_option(-device)
+    _fixTabs
+}
+
+# ----------------------------------------------------------------------
+# CONFIGURATION OPTION: -tool
+#
+# Set to the Rappture::Library object containing tool parameters.
+# Needed only if controls are added to the widget, so the controls
+# can update the tool parameters.
+# ----------------------------------------------------------------------
+itcl::configbody Rappture::DeviceViewer1D::tool {
+    if {$itk_option(-tool) != ""} {
+        if {![Rappture::Library::valid $itk_option(-tool)]} {
+            error "bad value \"$itk_option(-tool)\": should be Rappture::Library"
+        }
+    }
+    set _tool $itk_option(-tool)
+}
Index: trunk/gui/scripts/dispatcher.tcl
===================================================================
--- trunk/gui/scripts/dispatcher.tcl	(revision 6716)
+++ trunk/gui/scripts/dispatcher.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: dispatcher - central notification mechanism
@@ -14,8 +13,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itcl
@@ -46,5 +42,5 @@
     private variable _extraargs      ;# extra args for dispatch calls
 }
-
+                                                                                
 # ----------------------------------------------------------------------
 # CONSTRUCTOR
@@ -53,5 +49,5 @@
     # nothing to do
 }
-
+                                                                                
 # ----------------------------------------------------------------------
 # DESTRUCTOR
@@ -225,5 +221,4 @@
 # ----------------------------------------------------------------------
 # USAGE: cancel ?!event ...?
-#        cancel all
 #
 # Used to cancel any event notifications pending for the specified
@@ -232,13 +227,7 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::DispatchObj::cancel {args} {
-    if { $args == "all" } {
-        foreach event [array names _event2clients] {
-            after cancel [itcl::code $this _send $event all @extra]
-        }
-        return
-    }
     foreach event $args {
         if {![info exists _event2clients($event)]} {
-            error "bad event \"$event\": should be [join [lsort [array names _event2clients]] {, }]"
+            error "bad event \"$str\": should be [join [lsort [array names _event2clients]] {, }]"
         }
         after cancel [itcl::code $this _send $event all @extra]
Index: trunk/gui/scripts/dropdown.tcl
===================================================================
--- trunk/gui/scripts/dropdown.tcl	(revision 6716)
+++ trunk/gui/scripts/dropdown.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: dropdown - base class for drop-down panels
@@ -9,8 +8,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
@@ -19,5 +15,5 @@
 option add *Dropdown.outline black widgetDefault
 option add *Dropdown.borderwidth 1 widgetDefault
-option add *Dropdown.font -*-helvetica-medium-r-normal-*-12-* widgetDefault
+option add *Dropdown.font -*-helvetica-medium-r-normal-*-*-120-* widgetDefault
 
 itcl::class Rappture::Dropdown {
@@ -85,5 +81,5 @@
     set h [winfo height $itk_component(hull)]
     set sw [winfo screenwidth $itk_component(hull)]
-    set sh [winfo screenheight $itk_component(hull)]
+    set sh [winfo screenwidth $itk_component(hull)]
 
     if {[regexp {^@([0-9]+),([0-9]+)$} $where match x y]} {
